"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.makeActionCreator = void 0;

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// Returns a function to create actions of given type
var makeActionCreator = function makeActionCreator(type) {
  // First argument passed becomes payload property of action
  //  Second argument is object that becomes spread inside action
  var actionCreator = function actionCreator(payload, meta) {
    var spread = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    return _objectSpread({
      type: type,
      payload: payload,
      meta: meta
    }, spread);
  };

  actionCreator.type = type;
  return actionCreator;
};

exports.makeActionCreator = makeActionCreator;