"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.makeCustomActions = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _makeActionTemplate = require("../template/makeActionTemplate");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var makeCustomActions = function makeCustomActions() {
  var reducersDict = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var pathToLeafOrBranch = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  var actionTemplate = (0, _makeActionTemplate.makeActionTemplate)(pathToLeafOrBranch, {
    custom: true
  });
  return _lodash["default"].mapValues(reducersDict, function (leafReducer, creatorKey) {
    return makeCustomActionCreator(leafReducer, creatorKey, actionTemplate);
  });
};

exports.makeCustomActions = makeCustomActions;

var makeCustomActionCreator = function makeCustomActionCreator(leafReducer, creatorKey, actionTemplate) {
  var argsToPayload = leafReducer.argsToPayload;
  return function () {
    var payload = argsToPayload.apply(void 0, arguments);
    return actionTemplate(creatorKey, payload, leafReducer.type);
  };
};