"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.forAny = void 0;

var _atomic = require("../../atomic");

var _makeActionTemplate = require("../../template/makeActionTemplate");

var forAny = function forAny() {
  var pathToLeafOrBranch = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var actionTemplate = (0, _makeActionTemplate.makeActionTemplate)(pathToLeafOrBranch);

  var apply = function apply(callback) {
    return actionTemplate(_atomic.atomicActions.APPLY, callback);
  };

  var clear = function clear() {
    var toNull = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
    return actionTemplate(_atomic.atomicActions.CLEAR, toNull);
  };

  var reset = function reset() {
    return actionTemplate(_atomic.atomicActions.RESET);
  };

  var update = function update(value) {
    return actionTemplate(_atomic.atomicActions.UPDATE, value);
  };

  return {
    apply: apply,
    clear: clear,
    reset: reset,
    update: update
  };
};

exports.forAny = forAny;