"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.forArray = void 0;

var _atomic = require("../../atomic");

var _conditions = require("../../condtions/conditions");

var _makeActionTemplate = require("../../template/makeActionTemplate");

var forArray = function forArray() {
  var pathToLeafOrBranch = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var actionTemplate = (0, _makeActionTemplate.makeActionTemplate)(pathToLeafOrBranch, {
    condition: _conditions.conditions.ARRAY
  });

  var concat = function concat(array) {
    return actionTemplate(_atomic.atomicActions.CONCAT, array);
  };

  var drop = function drop() {
    var n = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
    return actionTemplate(_atomic.atomicActions.DROP, n);
  };

  var filter = function filter(callback) {
    return actionTemplate(_atomic.atomicActions.FILTER, callback);
  };

  var push = function push(element) {
    var index = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : -1;
    var replace = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
    return actionTemplate(_atomic.atomicActions.PUSH, {
      element: element,
      index: index,
      replace: replace
    });
  };

  return {
    concat: concat,
    drop: drop,
    filter: filter,
    push: push
  };
};

exports.forArray = forArray;