"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.replaceAtIndex = exports.insertAtIndex = exports.deleteAtIndex = exports.atIndex = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

var atIndex = function atIndex(array, index) {
  return array[positiveIndex(array, index)];
};

exports.atIndex = atIndex;

var deleteAtIndex = function deleteAtIndex(arr, idx) {
  return [].concat(_toConsumableArray(arr.slice(0, positiveIndex(arr, idx))), _toConsumableArray(arr.slice(positiveIndex(arr, idx) + 2)));
};

exports.deleteAtIndex = deleteAtIndex;

var insertAtIndex = function insertAtIndex(arr, idx, newVal) {
  return idx < 0 ? insertAfterIndex(arr, idx, newVal) : insertBeforeIndex(arr, idx, newVal);
};

exports.insertAtIndex = insertAtIndex;

var replaceAtIndex = function replaceAtIndex(arr, idx, newVal) {
  return _lodash["default"].map(arr, function (value, index) {
    return positiveIndex(arr, idx) === index ? newVal : value;
  });
};

exports.replaceAtIndex = replaceAtIndex;

var insertAfterIndex = function insertAfterIndex(arr, idx, newVal) {
  return [].concat(_toConsumableArray(arr.slice(0, positiveIndex(arr, idx) + 1)), [newVal], _toConsumableArray(arr.slice(positiveIndex(arr, idx) + 1)));
};

var insertBeforeIndex = function insertBeforeIndex(arr, idx, newVal) {
  return [].concat(_toConsumableArray(arr.slice(0, positiveIndex(arr, idx))), [newVal], _toConsumableArray(arr.slice(positiveIndex(arr, idx))));
};

var positiveIndex = function positiveIndex(array, index) {
  return index < 0 ? array.length + parseInt(index) : index;
};