"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.forBoolean = void 0;

var _atomic = require("../../atomic");

var _conditions = require("../../condtions/conditions");

var _makeActionTemplate = require("../../template/makeActionTemplate");

var forBoolean = function forBoolean() {
  var pathToLeafOrBranch = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var actionTemplate = (0, _makeActionTemplate.makeActionTemplate)(pathToLeafOrBranch, {
    condition: _conditions.conditions.BOOLEAN
  });

  var off = function off() {
    return actionTemplate(_atomic.atomicActions.OFF);
  };

  var on = function on() {
    return actionTemplate(_atomic.atomicActions.ON);
  };

  var toggle = function toggle() {
    return actionTemplate(_atomic.atomicActions.TOGGLE);
  };

  return {
    off: off,
    on: on,
    toggle: toggle
  };
};

exports.forBoolean = forBoolean;