"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.forNumber = void 0;

var _atomic = require("../../atomic");

var _conditions = require("../../condtions/conditions");

var _makeActionTemplate = require("../../template/makeActionTemplate");

var forNumber = function forNumber() {
  var pathToLeafOrBranch = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var actionTemplate = (0, _makeActionTemplate.makeActionTemplate)(pathToLeafOrBranch, {
    condition: _conditions.conditions.NUMBER
  });

  var increment = function increment() {
    var n = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
    return actionTemplate(_atomic.atomicActions.INCREMENT, n);
  };

  return {
    increment: increment
  };
};

exports.forNumber = forNumber;