"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.forObject = void 0;

var _atomic = require("../../atomic");

var _conditions = require("../../condtions/conditions");

var _makeActionTemplate = require("../../template/makeActionTemplate");

var forObject = function forObject() {
  var pathToLeafOrBranch = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var actionTemplate = (0, _makeActionTemplate.makeActionTemplate)(pathToLeafOrBranch, {
    condition: _conditions.conditions.OBJECT
  });

  var assign = function assign() {
    for (var _len = arguments.length, sources = new Array(_len), _key = 0; _key < _len; _key++) {
      sources[_key] = arguments[_key];
    }

    return actionTemplate(_atomic.atomicActions.ASSIGN, sources);
  };

  var set = function set(path, value) {
    return actionTemplate(_atomic.atomicActions.SET, {
      path: path,
      value: value
    });
  };

  return {
    assign: assign,
    set: set
  };
};

exports.forObject = forObject;