"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.forString = void 0;

var _atomic = require("../../atomic");

var _conditions = require("../../condtions/conditions");

var _makeActionTemplate = require("../../template/makeActionTemplate");

var forString = function forString() {
  var pathToLeafOrBranch = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var actionTemplate = (0, _makeActionTemplate.makeActionTemplate)(pathToLeafOrBranch, {
    condition: _conditions.conditions.STRING
  });

  var concat = function concat() {
    for (var _len = arguments.length, strings = new Array(_len), _key = 0; _key < _len; _key++) {
      strings[_key] = arguments[_key];
    }

    return actionTemplate(_atomic.atomicActions.CONCAT, strings);
  };

  var replace = function replace(pattern, replacement) {
    return actionTemplate(_atomic.atomicActions.REPLACE, {
      pattern: pattern,
      replacement: replacement
    });
  };

  return {
    concat: concat,
    replace: replace
  };
};

exports.forString = forString;