"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.makeActionTemplate = void 0;

var _defaults = require("../../reducersDict/standardise/defaults");

var changeCase = require('change-case');

var makeActionTemplate = function makeActionTemplate() {
  var path = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      condition = _ref.condition,
      custom = _ref.custom;

  return function (creatorKey, payload) {
    var actionType = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : _defaults.leafReducerDefaults.actionType;
    var CREATOR_KEY = changeCase.snakeCase(creatorKey).toUpperCase();
    var leaf = {
      path: path,
      condition: condition,
      creatorKey: creatorKey,
      CREATOR_KEY: CREATOR_KEY,
      custom: custom
    };
    var type = typeof actionType === "function" ? actionType(leaf, payload) : actionType;
    return {
      leaf: leaf,
      type: type,
      payload: payload
    };
  };
};

exports.makeActionTemplate = makeActionTemplate;