"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.leafReducerArray = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _atomic = require("../../actions/atomic");

var _utils = require("../../actions/for/array/utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var leafReducerArray = function leafReducerArray(leafState, _ref) {
  var creatorKey = _ref.creatorKey,
      payload = _ref.payload;
  var state = _lodash["default"].isArray(leafState) ? leafState : _lodash["default"].toArray(leafState);

  switch (creatorKey) {
    case _atomic.atomicActions.CONCAT:
      return concat(state, payload);

    case _atomic.atomicActions.DROP:
      return drop(state, payload);

    case _atomic.atomicActions.FILTER:
      return filter(state, payload);

    case _atomic.atomicActions.PUSH:
      return push(state, payload);

    default:
      return state;
  }
};

exports.leafReducerArray = leafReducerArray;

var concat = function concat(leafState, payload) {
  return leafState.concat(payload);
};

var drop = function drop(leafState, n) {
  return _lodash["default"].drop(leafState, n);
};

var filter = function filter(leafState, callback) {
  return leafState.filter(callback);
};

var push = function push(leafState) {
  var _ref2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      element = _ref2.element,
      _ref2$index = _ref2.index,
      index = _ref2$index === void 0 ? -1 : _ref2$index,
      _ref2$replace = _ref2.replace,
      replace = _ref2$replace === void 0 ? false : _ref2$replace;

  return replace ? (0, _utils.replaceAtIndex)(leafState, index, element) : (0, _utils.insertAtIndex)(leafState, index, element);
};