"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.leafReducerCustom = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var leafReducerCustom = function leafReducerCustom(reducersDict, leafState, _ref, wholeState) {
  var _ref$leaf = _ref.leaf,
      leaf = _ref$leaf === void 0 ? {} : _ref$leaf,
      payload = _ref.payload;
  var creatorKey = leaf.creatorKey;

  if (Object.keys(reducersDict).includes(creatorKey)) {
    var logic = reducersDict[creatorKey];
    return logic.reducer(_lodash["default"].cloneDeep(leafState), {
      payload: payload
    }, wholeState);
  } else {
    return leafState;
  }
};

exports.leafReducerCustom = leafReducerCustom;