"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.leafReducerObject = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _atomic = require("../../actions/atomic");

var _2 = require("../..");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

var leafReducerObject = function leafReducerObject(leafState, _ref) {
  var creatorKey = _ref.creatorKey,
      payload = _ref.payload;
  var state = _lodash["default"].isPlainObject(leafState) ? leafState : _lodash["default"].toPlainObject(leafState);

  switch (creatorKey) {
    case _atomic.atomicActions.ASSIGN:
      return assign(state, payload);

    case _atomic.atomicActions.SET:
      return set(state, payload);

    default:
      return state;
  }
};

exports.leafReducerObject = leafReducerObject;

var assign = function assign(state, sources) {
  return Object.assign.apply(Object, [_objectSpread({}, state)].concat(_toConsumableArray(sources)));
};

var set = function set(state, _ref2) {
  var path = _ref2.path,
      value = _ref2.value;
  return (0, _2.updateState)(state, path, value);
};