"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.leafReducerString = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _atomic = require("../../actions/atomic");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

var leafReducerString = function leafReducerString(leafState, _ref) {
  var creatorKey = _ref.creatorKey,
      payload = _ref.payload;
  var state = _lodash["default"].isString(leafState) ? leafState : _lodash["default"].toString(leafState);

  switch (creatorKey) {
    case _atomic.atomicActions.CONCAT:
      return concat.apply(void 0, [state].concat(_toConsumableArray(payload)));

    case _atomic.atomicActions.REPLACE:
      return replace(state, payload);

    default:
      return state;
  }
};

exports.leafReducerString = leafReducerString;

var concat = function concat(leafState) {
  for (var _len = arguments.length, strings = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    strings[_key - 1] = arguments[_key];
  }

  return leafState.concat.apply(leafState, strings);
};

var replace = function replace(leafState, _ref2) {
  var pattern = _ref2.pattern,
      replacement = _ref2.replacement;
  return leafState.replace(pattern, replacement);
};