"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.standardiseReducersDict = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _defaults = require("./defaults");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var standardiseReducersDict = function standardiseReducersDict() {
  var reducersDict = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return _lodash["default"].mapValues(reducersDict, defineLeafReducer);
};

exports.standardiseReducersDict = standardiseReducersDict;

var defineLeafReducer = function defineLeafReducer(definition) {
  return typeof definition === "function" ? defineLeafReducerFromFunction(definition) : defineLeafReducerFromConfig(definition);
};

var defineLeafReducerFromConfig = function defineLeafReducerFromConfig(config) {
  return _objectSpread({}, _defaults.leafReducerDefaults, config);
};

var defineLeafReducerFromFunction = function defineLeafReducerFromFunction(callback) {
  return defineLeafReducerFromConfig({
    reducer: callback
  });
};