"use strict";

var _lodash = _interopRequireDefault(require("lodash"));

var _reduxLeaves3 = require("./reduxLeaves");

var _redux = require("redux");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

describe("API: reduxLeaves(initialState)", function () {
  describe("GIVEN nested initialState with non-null values for shape { counter, foo, nested: { deep: {}, state: { manageable } } }", function () {
    var initialState = {
      counter: 1,
      foo: ["bar"],
      nested: {
        deep: {},
        state: {
          manageable: "maybe...?"
        }
      }
    };
    describe("WHEN [reducer, actions] = reduxLeaves(initialState)", function () {
      var _reduxLeaves = (0, _reduxLeaves3.reduxLeaves)(initialState),
          _reduxLeaves2 = _slicedToArray(_reduxLeaves, 2),
          reducer = _reduxLeaves2[0],
          actions = _reduxLeaves2[1];

      test("THEN reducer is a function", function () {
        expect(_typeof(reducer)).toBe("function");
      });
      test("AND actions.counter is an object", function () {
        expect(_typeof(actions.counter)).toBe("object");
      });
      test("AND actions.foo is an object", function () {
        expect(_typeof(actions.foo)).toBe("object");
      });
      test("AND actions.nested is an object", function () {
        expect(_typeof(actions.nested)).toBe("object");
      });
      test("AND actions.nested.deep is an object", function () {
        expect(_typeof(actions.nested.deep)).toBe("object");
      });
      test("AND actions.nested.state is an object", function () {
        expect(_typeof(actions.nested.state)).toBe("object");
      });
      test("AND actions.nested.state.manageable is an object", function () {
        expect(_typeof(actions.nested.state.manageable)).toBe("object");
      });
      describe("AND store = createStore(reducer)", function () {
        var store;
        beforeEach(function () {
          store = (0, _redux.createStore)(reducer);
        });
        test("THEN store is initialised with state = initialState", function () {
          expect(store.getState()).toEqual(initialState);
        });
      });
    });
  });
});