"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.updateState = exports.resetState = exports.getState = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var getState = function getState(state, path) {
  return pathIsEmpty(path) ? state : _lodash["default"].get(state, path);
};

exports.getState = getState;

var resetState = function resetState(state, path, initialState) {
  return updateState(state, path, getState(initialState, path));
};

exports.resetState = resetState;

var updateState = function updateState(state, path, val) {
  return pathIsEmpty(path) ? val : _lodash["default"].setWith(_lodash["default"].clone(state), path, val, _lodash["default"].clone);
};

exports.updateState = updateState;

var pathIsEmpty = function pathIsEmpty(path) {
  return ['', null, undefined].includes(path) || path.length === 0;
};